import com.aliasi.util.Files;
import com.aliasi.util.Strings;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;

import org.supercsv.io.CsvListReader;
import org.supercsv.io.CsvListWriter;
import org.supercsv.prefs.CsvPreference;

public class DedupeSimpleHash {

    public static void main(String[] args) throws IOException {
	int seenCounter = 0;
	File dataDir = new File(args[0]);
	File outDir = new File(args[1]);
	String outFile = args[2];
	List<String> texts = parseFile(dataDir);
	HashSet<String> seenBefore = new HashSet<String>();
	for (int i=0; i < texts.size(); ++i) {
	    String tweet = texts.get(i);
	    if (seenBefore.contains(tweet)) {
		++seenCounter;
		System.out.println("Seen Before at postition:" + i +": " + tweet);
	    }
	    else {
		seenBefore.add(tweet);
	    }
	}	
	File output = new File(outDir,outFile); 
	System.out.println("Writing to: " + output.toString());
	FileOutputStream stream =  new FileOutputStream(output);
	OutputStreamWriter streamWriter 
	    = new OutputStreamWriter(stream,Strings.UTF8);
	CsvListWriter writer 
	    = new CsvListWriter(streamWriter,CsvPreference.EXCEL_PREFERENCE); 
	ArrayList<String> row = new ArrayList<String>();
	row.add("");
	row.add("");
	row.add("");
	row.add("Unique Tweet");
	writer.write(row); //header for csv file
	for (String tweet : seenBefore) {
	    row.clear();
	    row.add("");
	    row.add("");
	    row.add("");
	    row.add(tweet);
	    writer.write(row);
	}
	writer.close();
	System.out.println(seenCounter + " seen of " + texts.size());
    }

    static List<String> parseFile(File file) throws IOException {
	List<String> tweets = new ArrayList<String>();
	FileInputStream fileInput = new FileInputStream(file);
	InputStreamReader fileReader = new InputStreamReader(fileInput,Strings.UTF8);
	CsvListReader reader
	    = new CsvListReader(fileReader, CsvPreference.EXCEL_PREFERENCE);
	int counter = 2;
	try {
	    String[] header = reader.getCSVHeader(true);
	    System.out.println(counter);
	    List<String> csv = null;
	    while ((csv = reader.read()) != null) {
		tweets.add(csv.get(TweetWriter.TWEET_OFFSET));
		++counter;
	    }
	    
	} finally {
	    reader.close();
	}
	return tweets;
    }
}
