import com.aliasi.sentences.IndoEuropeanSentenceModel;
import com.aliasi.sentences.HeuristicSentenceModel;
import com.aliasi.sentences.SentenceChunker;
import com.aliasi.sentences.SentenceModel;

import com.aliasi.chunk.Chunk;
import com.aliasi.chunk.Chunker;
import com.aliasi.chunk.Chunking;
import com.aliasi.chunk.ChunkingImpl;



import com.aliasi.tokenizer.Tokenizer;
import com.aliasi.tokenizer.TokenizerFactory;
import com.aliasi.tokenizer.IndoEuropeanTokenizerFactory;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.File;

import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class JobSentenceChunker implements Chunker {
		
    static HeuristicSentenceModel mSentenceModel;

    public JobSentenceChunker () {
	boolean forceFinalStop = true;
	boolean balanceParens  = false;
	Set<String> possibleStops = new HashSet<String>();
	possibleStops.add("\n");
	possibleStops.add(".");
	possibleStops.add(":");
	Set<String> impossibleStarts = new HashSet<String>();
	impossibleStarts.add(".");
	Set<String> impossiblePenultimate = new HashSet<String>();
	mSentenceModel
	    = new HeuristicSentenceModel(possibleStops,impossiblePenultimate,impossibleStarts
					 ,forceFinalStop,balanceParens);

    }


    public Chunking chunk(char[] chars, int start, int end) {
	return new ChunkingImpl(chars,start,end);
    }

    public Chunking chunk(CharSequence cseq) {
	char[] chars = cseq.toString().toCharArray();
	return chunk(chars,0,chars.length);
    }


    public static void main(String[] args) throws IOException, FileNotFoundException {
	List<String[]> docs = KeyPhrases.parseFile(new File(args[0]));
	Chunker sentenceChunker = new JobSentenceChunker();
	
	for (String[] doc : docs) {
	    System.out.println(doc.length);
	    Chunking sents = sentenceChunker.chunk(doc[KeyPhrases.BODY_INDEX]);
	    for (Chunk sent : sents.chunkSet()) {
		System.out.println("<s>" + doc[KeyPhrases.BODY_INDEX].substring(sent.start(),sent.end()) + "</s>");
	    }
	    
	}
    }

    
}