import com.aliasi.sentences.IndoEuropeanSentenceModel;
import com.aliasi.sentences.HeuristicSentenceModel;
import com.aliasi.sentences.SentenceChunker;
import com.aliasi.sentences.SentenceModel;

import com.aliasi.chunk.Chunk;
import com.aliasi.chunk.Chunker;
import com.aliasi.chunk.Chunking;


import com.aliasi.tokenizer.IndoEuropeanTokenizerFactory;
import com.aliasi.tokenizer.RegExTokenizerFactory;
import com.aliasi.tokenizer.Tokenizer;
import com.aliasi.tokenizer.Tokenization;
import com.aliasi.tokenizer.TokenizerFactory;


import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.File;

import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class JobSentenceModel implements SentenceModel {
		
    static HeuristicSentenceModel mSentenceModel;

    public JobSentenceModel () {
	boolean forceFinalStop = true;
	boolean balanceParens  = false;
	Set<String> possibleStops = new HashSet<String>();
	possibleStops.add("\n\n");
	possibleStops.add(".");
	possibleStops.add(":");
	Set<String> impossibleStarts = new HashSet<String>();
	impossibleStarts.add(".");
	Set<String> impossiblePenultimate = new HashSet<String>();
	mSentenceModel
	    = new HeuristicSentenceModel(possibleStops,impossiblePenultimate,impossibleStarts
					 ,forceFinalStop,balanceParens);
    }

    public int[] boundaryIndices(String[] tokens, String[] whitespaces) {
	return mSentenceModel.boundaryIndices(tokens,whitespaces);
    }

    public void boundaryIndices(String[] tokens,
				String[] whitespaces,
				int start,
				int end,
				Collection<Integer> indices) {
	
	mSentenceModel.boundaryIndices(tokens,whitespaces,start,end,indices);
    }

    public static void main(String[] args) throws IOException, FileNotFoundException {
	List<String[]> docs = KeyPhrases.parseFile(new File(args[0]));
	TokenizerFactory tokenizerFactory = new RegExTokenizerFactory("\\w+|\\.|:|\\n\\n");
	Chunker sentenceChunker = new SentenceChunker(tokenizerFactory,
						      new JobSentenceModel());
	
	for (String[] doc : docs) {
	    System.out.println(doc.length);
	    Chunking sents = sentenceChunker.chunk(doc[KeyPhrases.BODY_INDEX]);
	    
	    for (Chunk sent : sents.chunkSet()) {
		System.out.println("<s>" + doc[KeyPhrases.BODY_INDEX].substring(sent.start(),sent.end()) + "</s>");
	    }
	    
	}
    }

    
}