import com.aliasi.classify.PrecisionRecallEvaluation;

import com.aliasi.cluster.HierarchicalClusterer;
import com.aliasi.cluster.ClusterScore;
import com.aliasi.cluster.CompleteLinkClusterer;
import com.aliasi.cluster.SingleLinkClusterer;
import com.aliasi.cluster.Dendrogram;
import com.aliasi.cluster.KMeansClusterer;

import com.aliasi.features.LengthNormFeatureExtractor;

import com.aliasi.util.Counter;
import com.aliasi.util.Distance;
import com.aliasi.util.FeatureExtractor;
import com.aliasi.util.Files;
import com.aliasi.util.ObjectToCounterMap;
import com.aliasi.util.Strings;

import com.aliasi.tokenizer.*;
import com.aliasi.tokenizer.TokenFeatureExtractor;
import com.aliasi.io.Reporter;
import com.aliasi.io.Reporters;
import com.aliasi.io.LogLevel;



import java.io.*;
import java.util.*;
import java.util.Random;
import java.util.regex.Pattern;


public class KMeansCluster {



    public static void main(String[] args) throws Exception {
	String query = args[2];	
        File dataDir = new File(args[1]); // + ".csv");
	short numClusters = Short.valueOf(args[0]);
	int maxEpochs = 1000;
	boolean initializePlusPlus = true;
	double minImprovement = 0.0000001;
	String categories = args[3];
        FilteredXValCorpus corpus = new FilteredXValCorpus(NUM_FOLDS,dataDir,categories);
        CharSequence[] texts = corpus.texts();
        System.out.println("corpus.size=" + texts.length);
	System.out.println("number of topics=" + numClusters);
        int minTokenCount = 2;
	Random random = new Random(2104583);
	TokenizerFactory tokFactory = new QueryFilterTokenizerFactory(query);
	FeatureExtractor<CharSequence> featureExtractor
	    = new TokenFeatureExtractor(tokFactory);
	featureExtractor = new LengthNormFeatureExtractor<CharSequence>(featureExtractor);
	KMeansClusterer<CharSequence> kmCluster = 
	    new KMeansClusterer<CharSequence>(featureExtractor,numClusters,maxEpochs,initializePlusPlus,minImprovement);
	Reporter reporter = Reporters.stdOut();
	reporter.setLevel(LogLevel.TRACE);
	Set<Set<CharSequence>> clusters = kmCluster.cluster(corpus.textsCharSequence(),random,reporter);
	for (Set<CharSequence> cl : clusters) {
	    System.out.println("--------------------------");
	    for (CharSequence charSeq : cl) {
		System.out.println("\t" + charSeq);
	    }
	}
		
    }

    private static final int NUM_FOLDS = 0;

     static FeatureExtractor FEATURE_EXTRACTOR
        = new TokenFeatureExtractor(IndoEuropeanTokenizerFactory.INSTANCE);



    /*
    static final Distance<Document> COSINE_DISTANCE
        = new Distance<Document>() {
            public double distance(Document doc1, Document doc2) {
                double oneMinusCosine = 1.0 - doc1.cosine(doc2);
                if (oneMinusCosine > 1.0)
                    return 1.0;
                else if (oneMinusCosine < 0.0)
                    return 0.0;
                else
                    return oneMinusCosine;
            }
        };

    */
}