import com.aliasi.tokenizer.Tokenizer;
import com.aliasi.tokenizer.TokenizerFactory;
import com.aliasi.tokenizer.RegExTokenizerFactory;
import com.aliasi.tokenizer.LowerCaseTokenizerFactory;
import com.aliasi.tokenizer.EnglishStopTokenizerFactory;
import com.aliasi.tokenizer.RegExFilteredTokenizerFactory;
import com.aliasi.tokenizer.StopTokenizerFactory;

import com.aliasi.tokenizer.ModifyTokenTokenizerFactory;

import java.util.regex.Pattern;
import java.util.Set;
import java.util.HashSet;

public class QueryFilterTokenizerFactory implements TokenizerFactory {

    TokenizerFactory mTF;

    QueryFilterTokenizerFactory(String query) {
        TokenizerFactory tokenizerFactory
	    //            = IndoEuropeanTokenizerFactory.INSTANCE;
	    = new RegExTokenizerFactory("\\S+");
        tokenizerFactory = new LowerCaseTokenizerFactory(tokenizerFactory);
	tokenizerFactory = new HttpFilterTokenizerFactory(tokenizerFactory);
        tokenizerFactory = new EnglishStopTokenizerFactory(tokenizerFactory);
        tokenizerFactory = new RegExFilteredTokenizerFactory(tokenizerFactory,
                                                             Pattern.compile("\\w{3,}"));
	
	char[] queryChars = query.toCharArray();
	Tokenizer tokenizer = tokenizerFactory.tokenizer(queryChars,0,queryChars.length);
    	Set<String> stopList = new HashSet<String>();
	String token = null;
	while( (token = tokenizer.nextToken()) != null ) {
	    stopList.add(token);
	}

        mTF = new StopTokenizerFactory(tokenizerFactory,stopList);
    }

    public Tokenizer tokenizer(char[] chars, int start, int finish) {
	return mTF.tokenizer(chars,start,finish);
    }

	





static final long serialVersionUID = -7949489227829523271L;
}
