import com.aliasi.classify.Classification;
import com.aliasi.classify.Classified;
import com.aliasi.classify.ConditionalClassification;
import com.aliasi.classify.LogisticRegressionClassifier;

import com.aliasi.io.Reporter;
import com.aliasi.io.Reporters;

import com.aliasi.stats.AnnealingSchedule;
import com.aliasi.stats.RegressionPrior;

import com.aliasi.tokenizer.RegExTokenizerFactory;
import com.aliasi.tokenizer.TokenizerFactory;
import com.aliasi.tokenizer.TokenFeatureExtractor;

import com.aliasi.util.AbstractCommand;
import com.aliasi.util.AbstractExternalizable;
import com.aliasi.util.FeatureExtractor;
import com.aliasi.util.Pair;
import com.aliasi.util.Strings;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;


import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;


public class RunLogisticRegression extends AbstractCommand {

    int mNumFolds = 0;//entire corpus is visited on training

    public RunLogisticRegression(String[] args) {
	super(args);
    }

    public void run() {
	try {
	    process(getArgumentFile("model"));
	}
	catch (Exception e) {
	    System.out.println("Problem with program. Got exception " + e);
            e.printStackTrace(System.out);
	}
    }

    void process(File model) throws IOException, ClassNotFoundException {

	PrintWriter progressWriter = new PrintWriter(System.out,true);

        progressWriter.println("Reading data.");

	@SuppressWarnings("unchecked")
	    

	LogisticRegressionClassifier<CharSequence> classifier 
	    = (LogisticRegressionClassifier<CharSequence>) AbstractExternalizable.readObject(model);

	String status = "Going to rent a video tonight";
	
	Classification classification = classifier.classify(status);
	progressWriter.println("String: \"" + status + "\" has classifications \n" + classification);
    }
    
    public static void main(String[] args) {
	RunLogisticRegression cmd = new RunLogisticRegression(args);
	cmd.run();
    }

}