import twitter4j.Twitter;

import java.io.File;
import java.io.IOException;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import twitter4j.Query;
import twitter4j.QueryResult;
import twitter4j.Tweet;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;


public class SearchTwitter4j {

    static final int TWEETS_PER_PAGE = 100;
    static final int NUM_PAGES = 15;

    public static void main (String[] args) 
        throws IOException, TwitterException {

        String queryString = args[0];
        File outDir = new File(args[1]);

        Twitter twitter = new TwitterFactory().getInstance();

        Query query = new Query(queryString);
        query.setRpp(TWEETS_PER_PAGE);

        List<Tweet> tweets = new ArrayList<Tweet>();
        for (int i = 1; i <= NUM_PAGES; ++i) {
            query.setPage(i);
            QueryResult result = twitter.search(query);
            List<Tweet> resultTweets = result.getTweets();
            if (resultTweets.size() == 0) break;
            tweets.addAll(resultTweets);
        }

        System.out.println("writing to disk in directory= " + outDir);
        TweetWriter.writeCsv(tweets,outDir,queryString,"csv");

    }

}

