import com.aliasi.corpus.Corpus;

import com.aliasi.tokenizer.IndoEuropeanTokenizerFactory;
import com.aliasi.tokenizer.NGramTokenizerFactory;
import com.aliasi.tokenizer.PorterStemmerTokenizerFactory;
import com.aliasi.tokenizer.RegExTokenizerFactory;
import com.aliasi.tokenizer.SoundexTokenizerFactory;
import com.aliasi.tokenizer.TokenizerFactory;
import com.aliasi.tokenizer.Tokenizer;
//import com.aliasi.tokenizer.TokenNGramTokenizerFactory;

import com.aliasi.util.ObjectToCounterMap;

import java.io.File;
import java.io.IOException;
import java.io.Serializable;

import java.util.Set;

public class TweetTokens implements TokenizerFactory, Serializable {

    TokenizerFactory mTokenizerFactory = null;

    public TweetTokens () {
	mTokenizerFactory 
	    = new RegExTokenizerFactory("\\S+");

		mTokenizerFactory
	= IndoEuropeanTokenizerFactory.INSTANCE;
		//mTokenizerFactory 
		//    = new PorterStemmerTokenizerFactory(mTokenizerFactory);
	//mTokenizerFactory = new SoundexTokenizerFactory(mTokenizerFactory);

	//mTokenizerFactory  = new NGramTokenizerFactory(3,3);

	//mTokenizerFactory = new TokenNGramTokenizerFactory(mTokenizerFactory,
	//					   2,2);
    }


    public Tokenizer tokenizer(char[] cs, int start, int end) {
	return mTokenizerFactory.tokenizer(cs,start,end);
    }

    static final long serialVersionUID = -666;

     public static void main(String[] args) throws IOException {
	 
	 TokenizerFactory tokFactory = new TweetTokens();
	 File data = new File(args[0]);
	 int numFolds = 10;
	 Set<String> keepers = null;
	 FilteredXValCorpus corpus 
	     = new FilteredXValCorpus(numFolds,data,keepers);
	 String[] tweets = corpus.texts();
	 ObjectToCounterMap<String> counter 
	     = new ObjectToCounterMap<String>();
	for (String tweet : tweets) {
	    System.out.println(tweet);
	    char[] chars = tweet.toCharArray();
	    Tokenizer tokenizer 
		= tokFactory.tokenizer(tweet.toCharArray(),0,chars.length);
	    String token = null;
	    System.out.println("'" + tokenizer.nextWhitespace() + "'");
	    while( (token = tokenizer.nextToken()) != null ) {
                System.out.println("'" + token + "'");
		System.out.println("'" + tokenizer.nextWhitespace() + "'");
		counter.increment(token);
	    }
	}
	
	System.out.println("Counter:------------\n" + counter);
    }


	    

}